###################################################
### chunk number 1: PreliminaryCalculations
###################################################
#line 25 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
library(mvtnorm)
library(hbim)
NSIM<-5*10^5
SIGMAS.POWER<-c(9,65,5000)
SIGMAS<-log10(SIGMAS.POWER)/(2*qnorm(.975))
SCOLORS<-c("green","blue","red")
FACTORS<-c(1/10, 1/3, 1/2, 1)
FCOLORS<-c("red", "green", "blue", "black")
RHOS<-c(-.5,-.25,0, 0.25, 0.5, 0.75, 1)
RCOLORS<- c("purple","blue","black","green","yellow","red","black")
RECALCULATE.OUTPUT<-FALSE
#RECALCULATE.OUTPUT<-TRUE
time0<-proc.time()
if (RECALCULATE.OUTPUT){
    set.seed(1234521)
    MU<-((-40:40)/10)
    deff.sigma<-eff.sigma(mu=MU, sigmas=SIGMAS, COLORS = SCOLORS, rho = 0)
    deff.mu<-eff.mu(mu=MU, factor = FACTORS, COLORS = FCOLORS, sigma = SIGMAS[2], rho = 0)
    deff.rho<-eff.rho(mu=MU, sigma = SIGMAS[2], rho = RHOS, COLORS =RCOLORS,simulate=TRUE,nsim=NSIM)
    set.seed(32401)
    dpp.sigma<-pp.sigma(MU,sigmas=SIGMAS,COLORS = SCOLORS, rho = 0,nsim=NSIM)
    set.seed(21345123)
    dpp.mu<-pp.mu(MU,factor = FACTORS, COLORS = FCOLORS, sigma = SIGMAS[2], rho = 0, nsim=NSIM)
    set.seed(435919)
    dpp.rho<-pp.rho(MU,sigma = SIGMAS[2], rho = RHOS, COLORS =RCOLORS,nsim=NSIM)
     
}else{
    ## load from previously calculated
    data(deff.sigma)
    data(deff.mu)
    data(deff.rho)
    data(dpp.sigma)
    data(dpp.mu)
    data(dpp.rho)
}
time1<-proc.time()


###################################################
### chunk number 2: 
###################################################
#line 356 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
data(irdata)
irdata[35,]


###################################################
### chunk number 3: 
###################################################
#line 368 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
refnum<- irdata[35,"Reference"]
data(refs)
refs[refnum]


###################################################
### chunk number 4: 
###################################################
#line 384 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
calc.foldrange<-function(n,lower,upper,conf.level=.95){
    alpha<-1-conf.level
    s.t<- 
(sqrt(n)*(log10(upper)-log10(lower)))/(2*qt(1-alpha/2,n-1))
    s.z<-(sqrt(n)*(log10(upper)-log10(lower)))/(2*qnorm(1-alpha/2))
    range.t<- 10^(( qnorm(1-alpha/2) - qnorm(alpha/2) )*s.t )
    range.z<- 10^(( qnorm(1-alpha/2) - qnorm(alpha/2) )*s.z )
    col.names<-c("n",paste("lower",100*conf.level,"% cl"),
           paste("upper",100*conf.level,"% cl"),
           "standard deviation (log10 scale) by t",
           "standard deviation (log10 scale) by Z",
           paste(100*conf.level,"% fold-range, s estimated by t"),
           paste(100*conf.level,"% fold-range, s estimated by Z"))
    
out<-data.frame(n=n,lower=lower,upper=upper,s.byt=s.t,s.byz=s.z,
        foldrange.byt=range.t,foldrange.byz=range.z)

    #out<-list(out,row.names)
    out
}


###################################################
### chunk number 5: 
###################################################
#line 407 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
calc.foldrange(203,65.2,87.6)


###################################################
### chunk number 6: 
###################################################
#line 413 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
frall<-calc.foldrange(irdata$n,irdata$GMT.95.pct.interval.low.limit,irdata$GMT.95.pct.interval.high.limit)
frall[1:5,]


###################################################
### chunk number 7: 
###################################################
#line 422 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
quantile(frall[,"foldrange.byt"],probs=c(0,.025,.50,.975,1))
quantile(frall[,"foldrange.byz"],probs=c(0,.025,.50,.975,1))


###################################################
### chunk number 8: 
###################################################
#line 427 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
quantile(frall[,"s.byt"],probs=c(0,.025,.50,.975,1))
quantile(frall[,"s.byz"],probs=c(0,.025,.50,.975,1))


###################################################
### chunk number 9: fig1
###################################################
#line 454 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
do.fig1<-function(IRDATA){
    age<-as.character(IRDATA$Age.in.yrs.at.first.vaccination)
    antigen<-as.character(IRDATA$Antigen)
    uage<-sort(unique(age))
    pick.fig1<- age<"1" & antigen!="A" & antigen!="C" & antigen!="FIM" &
        antigen!="W135" & antigen!="Y" & antigen!="PRP*"

    alevels<-c("1","3","4","5","6B","7F","9V","14","18C","19F","23F","MenC",
        "PRP","DT","FHA","PRN","PT","TT","HBs","Polio-1","Polio-2","Polio-3")
    fig1.data<-IRDATA[pick.fig1,c("Antigen","n",
        "GMT.95.pct.interval.low.limit","GMT.95.pct.interval.high.limit")]
    cf<-calc.foldrange(fig1.data$n,fig1.data$GMT.95.pct.interval.low.limit,
        fig1.data$GMT.95.pct.interval.high.limit)

    nfig1<-dim(fig1.data)[[1]]
    x<-COL<-rep(NA,nfig1)
    bit<-.4
    bit2<-1
    space<-1
    xlevels<-c((0:10)*bit,10*bit+space+bit2*(0:7),10*bit+space+bit2*7+space+bit*(0:2))
    collevels<-c(rep("blue",11),"slateblue4","aquamarine","green","red","red1","red2","orange","black","pink3","pink","pink1")
    for (i in 1:length(alevels)){
        x[fig1.data$Antigen==alevels[i]]<-xlevels[i]
        COL[fig1.data$Antigen==alevels[i]]<-collevels[i]
    }

    fig1.data<-data.frame(antigen=ordered(fig1.data$Antigen,levels=alevels),
        foldrange=cf[,"foldrange.byt"]) 
    par(oma=c(4,0,0,0))
    plot(range(x),log10(range(fig1.data$foldrange)),type="n",ylab="95% fold range",xlab="",axes=FALSE)
    box()
    axis(2,at=c(1,2,3,4),labels=c("10","100","1000","10000"))
    axis(1,at=xlevels[c(6,12:19,21)],
        labels=c("Pneumonococcal","Meningococcal","HiB",
        "Diptheria Toxin","Pertussis FHA","Pertussis PRN",
        "Pertussis Toxin","Tetanus Toxin","HBSAg","Polio"),las=2,cex=.5)
    points(x,log10(fig1.data$foldrange),col=COL,cex=1.5,pch=18)
}
do.fig1(irdata)


###################################################
### chunk number 10: 
###################################################
#line 501 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
sigmas<-SIGMAS


###################################################
### chunk number 11: 
###################################################
#line 517 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
V<-matrix( c(sigmas[2],0,0,sigmas[2]),2,2) 
V
mu<-c(.1,.1)
hbrr(mu,V)


###################################################
### chunk number 12: 
###################################################
#line 531 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
SIGMAS


###################################################
### chunk number 13:  eval=FALSE
###################################################
## #line 536 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
## data(deff.sigma)
## plotlogm.resp(deff.sigma)


###################################################
### chunk number 14: fig2
###################################################
#line 546 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
plotlogm.resp(deff.sigma)


###################################################
### chunk number 15: fig3a
###################################################
#line 563 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
plotresp.mix(deff.sigma)


###################################################
### chunk number 16: equiv.increase
###################################################
#line 580 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
D<-deff.sigma
equiv.increase(D$mu,D$out1[,2],D$mu,D$out2[,2],.5)
D<-dpp.sigma
equiv.increase(D$mu,D$out1[,2],D$mu,D$out2[,2],50)


###################################################
### chunk number 17: explanationfig3b
###################################################
#line 591 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
par(mfrow=c(1,1))
plot(c(-2,2),c(0,1),axes=FALSE,xlab="Standardized Geometric Mean Antibody",ylab="Efficacy",type="n")
#axis(1,at=c(-2,-1,0,1,2),labels=as.character(c(.01,.1,1,10,100)))
#axis(2)
box()
lines(deff.sigma$mu,deff.sigma$out1[,1],lty=1,col=deff.sigma$col1[1])
lines(deff.sigma$mu,deff.sigma$out2[,1],lty=5,col=deff.sigma$col2[1])

a1<-0
e1<-deff.sigma$out1[,1][deff.sigma$mu==a1]
e2<-deff.sigma$out2[,1][deff.sigma$mu==a1]
NOTNA<-!is.na( deff.sigma$out1[,1] ) & !is.na(deff.sigma$mu )
a2<-approx(deff.sigma$out1[NOTNA,1],deff.sigma$mu[NOTNA],xout=e2)$y

lines(c(a1,a1),c(-1,e2),lty=2,col="grey")
lines(c(-4,a2),c(e2,e2),lty=2,col="grey")
lines(c(-4,a1),c(e1,e1),lty=2,col="grey")
lines(c(a2,a2),c(-1,e2),lty=2,col="grey")

axis(2,at=c(e1),labels=expression(e[1]))
axis(2,at=c(e2),labels=expression(e[2]))
axis(1,at=c(a1),labels=expression(a[1]))
axis(1,at=c(a2),labels=expression(a[2]))


###################################################
### chunk number 18: fig3b
###################################################
#line 624 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
plotresp.equiv(deff.sigma)


###################################################
### chunk number 19: figppsigma
###################################################
#line 646 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
plotlogm.resp(dpp.sigma,YLIM=c(0,100),YLAB="Percent Protected")


###################################################
### chunk number 20: fig3c
###################################################
#line 662 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
plotresp.mix(dpp.sigma,XYLIM=c(0,100),RLAB="% Protected by")


###################################################
### chunk number 21: figfirsttry3d
###################################################
#line 677 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
plotresp.equiv(dpp.sigma,XLIM=c(0,100),RLAB="% Protected by")


###################################################
### chunk number 22: fig3d
###################################################
#line 694 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
plotresp.equiv(dpp.sigma,XLIM=c(0,100),RLAB="% Protected by",bounds=c(.01,99.9))


###################################################
### chunk number 23: 
###################################################
#line 716 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
FACTORS


###################################################
### chunk number 24: figLogmeanEffMu
###################################################
#line 732 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
plotlogm.resp(deff.mu)


###################################################
### chunk number 25: figLogmeanPPMu
###################################################
#line 741 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
plotlogm.resp(dpp.mu,YLIM=c(0,100),YLAB="Percent Protected")


###################################################
### chunk number 26: fig4a
###################################################
#line 753 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
plotresp.mix(deff.mu)


###################################################
### chunk number 27: fig4b
###################################################
#line 762 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
plotresp.equiv(deff.mu)


###################################################
### chunk number 28: fig4c
###################################################
#line 771 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
plotresp.mix(dpp.mu,XYLIM=c(0,100),RLAB="% Protected by")


###################################################
### chunk number 29: fig4d
###################################################
#line 780 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
plotresp.equiv(dpp.mu,XLIM=c(0,100),RLAB="% Protected by",bounds=c(.01,99.9))


###################################################
### chunk number 30: 
###################################################
#line 795 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
RHOS


###################################################
### chunk number 31: figLogmeanEffMu
###################################################
#line 814 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
plotlogm.resp(deff.rho)


###################################################
### chunk number 32: figLogmeanPPMu
###################################################
#line 823 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
plotlogm.resp(dpp.rho,YLIM=c(0,100),YLAB="Percent Protected")


###################################################
### chunk number 33: fig5a
###################################################
#line 834 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
plotresp.mix(deff.rho)


###################################################
### chunk number 34: fig5b
###################################################
#line 843 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
plotresp.equiv(deff.rho)


###################################################
### chunk number 35: fig5c
###################################################
#line 852 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
plotresp.mix(dpp.rho,XYLIM=c(0,100),RLAB="% Protected by")


###################################################
### chunk number 36: fig5d
###################################################
#line 861 "d:/Rcompile/CRANpkg/local/2.12/hbim/inst/doc/hbimdetails.Rnw"
plotresp.equiv(dpp.rho,XLIM=c(0,100),RLAB="% Protected by",bounds=c(.01,99.9))


